#!/usr/bin/perl -w

# Use CPAN to get any of the modules that might be missing.  For example:
# perl -MCPAN -e "install Digest::HMAC_SHA1"
#
## call: #!hmac_date.pl datestring secreatekey
### return the hmac_sha1_hex of the key and reuesti date
use strict;
use Digest::HMAC_SHA1 qw(hmac_sha1_hex);
#use HTTP::Date;
#use Config::Properties;

my ($requestDate,$secretKey)=@ARGV;
#
## Set header values:
#my $time =time() ;
#my $requestDate = time2str($time);
#print "\nDate:$requestDate vs $secretKey\n";
my $hmac = hmac_sha1_hex($requestDate, $secretKey);
####
print $hmac;
