#!/usr/bin/perl
use strict;

use vars qw/$db_file $cp_bin $cp_lib $cp_front $themename $src_dir $plugin_install_file $plugin_module_file $plugin_hook_file $plugin_module_file2 $plugin_front_dir/;

$themename= $ARGV[1];
##?$ARGV[1]:'x3';
$themename or $themename='x3';

$src_dir = $ARGV[2]?$ARGV[2]:'.';


$cp_bin = '/usr/local/cpanel/bin';
$cp_lib = '/usr/local/cpanel/Cpanel';
$cp_front = "/usr/local/cpanel/base/frontend/$themename";

$plugin_install_file='dnsmeapi.cpanelplugin';
$plugin_module_file='DNSmeapi.pm';
$plugin_hook_file='DNSmeapiHook.pm';
$plugin_module_file2 = 'hmac_date.pl';
$plugin_front_dir='dnsmeapi';
$db_file='/var/cpanel/dnsmeapi.db';
##print "\n$cp_front";exit;

### install cpanle plugin script
if($ARGV[0] eq 'uninstall'){
	do_uninstall();
}elsif($ARGV[0] eq 'install'){

	do_install();

}elsif($ARGV[0] eq 'frontend'){
	copy_fontend();
}elsif($ARGV[0] eq 'lib'){
	intall_lib();
}elsif($ARGV[0] eq 'copy'){
	do_copy();

}else{
	do_usage();

}
sub intall_lib{
	my $perl_lib = '/usr/local/cpanel/perl';
	my $file_name='Dumper.pm';
	my $dir = "$perl_lib/Data";
	unless(-d $dir){
		mkdir $dir;
	}
	my $file = "$dir/$file_name";
	unless(-e $file){
		`cp -f $src_dir/$file_name $dir`;
	}
	### dist


}
sub copy_fontend{
	print system("cp -rf $src_dir/$plugin_front_dir $cp_front/");

	### also copy the submain/index.html
	unless(-e "$cp_front/addon/index.html.bak"){

		print system("cp -f $cp_front/addon/index.html $cp_front/addon/index.html.bak");
	}
	print system("cp -f $src_dir/$plugin_front_dir/addon_index.html $cp_front/addon/index.html");
}
sub do_usage{
	print "'DNS Madeeasy API plugin\n\n";
	print "'./install.pl install' to install the plugin\n";
	print "'./install.pl uninstall' to uninstall the plugin\n";
	print "'./install.pl install x3' to install the plugin with x3 as the them\n";
	print "'./install.pl uninstall x3' to uninstall the plugin  with x3 as the them\n";
	##print "'./install.pl install' to install the plugin\n";

}

sub do_copy{

	my($src_file,$dest_file)=();
	print system("cp -f $src_dir/$plugin_install_file $cp_bin/$plugin_install_file");

	print system("cp -f $src_dir/$plugin_module_file $cp_lib/$plugin_module_file");
	print system("cp -f $src_dir/$plugin_module_file2 $cp_lib/$plugin_module_file2");
	print system("cp -f $src_dir/$plugin_hook_file $cp_lib/$plugin_hook_file");
	print system("chmod 0755 $cp_lib/$plugin_module_file2");
	### copy fonentfile
	### also create a link in /var/cpael/perl5/lib
	my $lib_dir = "/var/cpanel/perl5/lib";
	`mkdir -p $lib_dir`;
	unless(-e "$lib_dir/$plugin_hook_file"){

		`ln -s $cp_lib/$plugin_hook_file $lib_dir/$plugin_hook_file`;
	}
	### copy Admin Application
	my $admin_bin_path ="bin/admin/DNSmeapiNS";
	$lib_dir = "/usr/local/cpanel/$admin_bin_path";
	`mkdir -p $lib_dir`;
	`cp -f $admin_bin_path/DNSmeapiAdmin $lib_dir/DNSmeapiAdmin`;
	`cp -f $admin_bin_path/DNSmeapiAdmin.conf $lib_dir/DNSmeapiAdmin.conf`;

	&copy_fontend();
}

sub do_install{

	## unzip the package??
	### copy plugininstall file to /usr/local/cpanel
	my($src_file,$dest_file)=();
	do_copy();
	### register hoooks
	print system("/usr/local/cpanel/bin/manage_hooks add module DNSmeapiHook");

	#/usr/local/cpanel/bin/register_cpanelplugin <full path to install file>
	print system("/usr/local/cpanel/bin/register_cpanelplugin $cp_bin/$plugin_install_file");
	### copy backen files
	$db_file='/var/cpanel/dnsmeapi.db';
	unless(-e $db_file){
		open(my $fh,">$db_file") or die "could not create $db_file file. Reason;" . $!;
		print $fh "#dummpy row\n";
		close($fh);
		chmod 0666, $db_file;

	}

	## install lib
	&intall_lib();
	print "\nAll Done.";
}

sub do_uninstall{

	###/usr/local/cpanel/bin/unregister_cpanelplugin <full path to install file>
	print system("/usr/local/cpanel/bin/unregister_cpanelplugin $cp_bin/$plugin_install_file");

	### unregiser hooks
	print system("/usr/local/cpanel/bin/manage_hooks del module DNSmeapiHook");
	print system("cp -f $cp_front/addon/index.html.bak $cp_front/addon/index.html");
	### remove fontend file?
	print system("rm -rf $cp_front/$plugin_front_dir");
	### remove backend file?
	print system("rm -f $cp_bin/$plugin_module_file");





	print "\nAll Done.";
}
